
//////////////////////////////////////////////////////////////////////////////////
// Company: 武汉芯路恒科技有限公司
// Engineer: 小梅哥团队
// Web: www.corecourse.cn
// 
// Create Date: 2021/08/20 00:00:00
// Design Name: uart_rtc8563_hex8
// Module Name: uart_rtc8563_hex8
// Project Name: uart_rtc8563_hex8
// Target Devices: EP4CE10F17C8
// Tool Versions: Quartus II 13.0 64-bit
// Description: hex8项目的顶层文件，协调VIO，hex8和hc595的工作和接口
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////
module hex_top_special_for_rtc(
	clk,
	reset_n,
	disp_data,
	sh_cp,
	st_cp,
	ds,
	sel,
	seg
);

	input clk;	//50M
	input reset_n;
	input disp_data;
	
	output sh_cp;
	output st_cp;
	output ds;
	
	wire [31:0]disp_data;
	output wire [7:0] sel;//数码管位选（选择当前要显示的数码管）
	output wire [6:0] seg;//数码管段选（当前要显示的内容)
	
/*	vio_0 vio_0 (
		.clk(clk), 
		.probe_out0(disp_data)  
);*/
	
	hc595_driver hc595_driver(
		.clk(clk),
		.reset_n(reset_n),
		.data({1'd1,seg,sel}),
		.s_en(1'b1),
		.sh_cp(sh_cp),
		.st_cp(st_cp),
		.ds(ds)
	);
	
	hex8_special_for_rtc hex8_special_for_rtc(
		.clk(clk),
		.reset_n(reset_n),
		.en(1'b1),
		.disp_data(disp_data),
		.sel(sel),
		.seg(seg)
	);
	
endmodule
